;*Sterownik serwomechanizmw
;*sowo sterujce PaAbBcCdDeEfFgGhH gdzie
;* A,B,C,D,E,F,G,H nastawy 0..255

;**** includes ****

;include "1200def.inc"

.include "2312def.inc"

;
;*****************************
;* Global Register Variables *
;*****************************

.def	serwo_a= r2
.def	serwo_b= r3
.def	serwo_c= r4
.def	serwo_d= r5
.def	serwo_e= r6
.def	serwo_f= r7
.def	serwo_g= r8
.def	serwo_h= r9

.def	nast_a= r16
.def	nast_b= r17
.def	nast_c= r18
.def	nast_d= r19
.def	nast_e= r20
.def	nast_f= r21
.def	nast_g= r22
.def	nast_h= r23

.def	status	= r24		;bity statusu
.def	debug =	 r25	

.def	bitcnt	=R26			;bit counter
.def	temp	=R27			;temporary storage register

.def	Txbyte	=R28			;Data to be transmitted
.def	RXbyte	=R29
.def	temp1	= r30
.def	temp2	= r31
		;debug
.equ	t20_ms	= 0		;ustawiony - trwa przerwa 20 ms
.equ	t1_ms	= 1		; trwa poczatek impulsow 1 ms
.equ	rs_sleep=2		;

.equ	f20_ms	= 1		;maski do sbr cbr
.equ	f1_ms	= 2		; 
.equ	frs_sleep=4



;***** Pin definitions

.equ	RxD	=0			;Receive pin is PD0
.equ	TxD	=1			;Transmit pin is PD1

;***** Global register variables



.equ	Xon = 17	;
.equ	Xoff = 19
.equ	ACK = 6


;*********************
;* Interrupt Vectors *
;*********************

.CSEG
.org 0
	rjmp	RESET		; Reset Handle
	reti	
		
.org OVF0addr
	rjmp	TIM0_OVF	; Timer0 Overflow Handle
	reti			; Analog Comparator Handle (not used)


;***************************************************************************
;*
;* INTERRUPT
;*	TIM0_OVF - Timer/Counter0 Overflow Interrupt
;*
;***************************************************************************

TIM0_OVF:
	in	r0,SREG		; store SREG
	sbrc	status,t20_ms
		rjmp ms20_end		;do obslugi konca 20 ms
	sbrc	status,rs_sleep	;
		rjmp rs_end		;koniec odbioru
	sbrc	status,t1_ms
		rjmp ms1_end	;do obslugi konca 1 ms
		;trzy znaczniki wyzerowane czyli pocztek 20 ms
		
		ldi temp1,180	;190=16.9 ms dla TCCR0 = 5
		out TCNT0,temp1
		
		clr temp1
		out PORTB,temp1	;niskie wyjcia
		
		sbr status,f20_ms	;trwa 20 ms
		rjmp t0_end

ms20_end:	ldi temp1,251		;ok 1 ms
		out TCNT0,temp1
		cbr status,f20_ms
		sbr status,frs_sleep	;znaczniki
		
		rjmp t0_end

ms1_end:	
		
		ldi temp1,248		;ok 2 ms
		out TCNT0,temp1
		
		cbr status,f20_ms
		cbr status,f1_ms	;znaczniki
		rjmp	t0_end


rs_end:
		ldi temp1,254		;ok 1 ms
		out TCNT0,temp1
		cbr status,frs_sleep
		sbr status,f1_ms	;znaczniki
	
t0_end: 
	
	
	
	out	SREG,r0	        ; restore SREG
	reti			; exit

;********************putchar**************************


.equ		sb	=2		;Number of stop bits (1, 2, ...)

putchar:	ldi	bitcnt,9+sb	;1+8+sb (sb is # of stop bits)
		com	Txbyte		;Inverte everything
		sec			;Start bit

putchar0:	brcc	putchar1	;If carry set
		cbi	PORTD,TxD	;    send a '0'
		rjmp	putchar2	;else	

putchar1:	sbi	PORTD,TxD	;    send a '1'
		nop

putchar2:	rcall UART_delay	;One bit delay
		rcall UART_delay

		lsr	Txbyte		;Get next bit
		dec	bitcnt		;If not all bit sent
		brne	putchar0	;   send next
					;else
		ret	

getchar:	ldi 	bitcnt,9	;8 data bit + 1 stop bit
		
getchar1:
		in 	temp1,TCNT0	;sprawd stan licznika
		sbrs   status,t20_ms	;wyskocz po 20 ms
		rjmp	getchar3
		sbic 	PIND,RxD	;Wait for start bit
		rjmp 	getchar1
		cli			;zablokuj przerwanie
		rcall UART_delay	;0.5 bit delay

getchar2:	rcall UART_delay	;1 bit delay
		rcall UART_delay		

		clc			;clear carry
		sbic 	PIND,RxD	;if RX pin high
		sec			;

		dec 	bitcnt		;If bit is stop bit
		breq 	getchar3	;   return
					;else
		ror 	Rxbyte		;   shift bit into Rxbyte
		rjmp 	getchar2	;   go get next

getchar3:	
		sei			;wcz przerwania
		ret


;***************************************************************************
;*
;* "UART_delay"
;*
;* This delay subroutine generates the required delay between the bits when
;* transmitting and receiving bytes. The total execution time is set by the
;* constant "b":
;*
;*	3b + 7 cycles (including rcall and ret)
;*
;* Number of words	:4 including return
;* Low registers used	:None
;* High registers used	:1 (temp)
;* Pointers used	:None
;*
;***************************************************************************
; Some b values: 	(See also table in Appnote documentation)
;
; 1 MHz crystal:
;   9600 bps - b=14
;  19200 bps - b=5
;  28800 bps - b=2
;
; 2 MHz crystal:
;  19200 bps - b=14
;  28800 bps - b=8
;  57600 bps - b=2

; 4 MHz crystal:
;  19200 bps - b=31
;  28800 bps - b=19
;  57600 bps - b=8
; 115200 bps - b=2

.equ	b	=31	;19200 bps @ 4 MHz crystal


UART_delay:	ldi	temp,b
UART_delay1:	dec	temp
		brne	UART_delay1

		ret

;***************************************************************************
;*
;* FUNCTION
;*	delay
;*
;* DESCRIPTION
;*	 Make a small delay.
;*
;***************************************************************************

delay:	ldi	temp2,4
dl:	dec	temp2
	brne	dl
	ret


;init funkcja do debugu nadaje wartosci nast_
init:
	ldi nast_a,128
	ldi nast_b,128
	ldi nast_c,128
	ldi nast_d,128
	ldi nast_e,128
	ldi nast_f,128
	ldi nast_g,128
	ldi nast_h,128
ret


	











;***************************************************************************
;*
;* RESET
;*
;* DESCRIPTION
;*	Initialization
;*
;***************************************************************************

RESET:	
	;clr debug
;**************** tylko 2313
	ldi temp1,0x5F+32
	out spl,temp1
;*******************************
	clr temp1
	out portb,temp1
	ser temp1
	out ddrb,temp1		;wyjscie
	
	sbi PORTD,TxD	;Init port pins
	sbi	DDRD,TxD
	ldi	Txbyte,12	;Clear terminal
	rcall	putchar
	clr status	
	rcall init
	ldi temp1,(1<<TOIE0)	;Enable timer interrupt
	out TIMSK,temp1
	sei			;Enable global interrupt
	ldi temp1,178		;20 ms
	out TCNT0,temp1
	ldi temp1,5
	out TCCR0,temp1	;timer clk/1024
	sbr status,f20_ms
	sei			; Enable interrupts
	
	
	

loop:	
	ldi txbyte,xon
	rcall putchar
	ldi txbyte,65	;'A' jak ACK
	rcall putchar
loop88:
	
	rcall getchar		
	sbrs status,t20_ms	
	rjmp loop77			
	
loop20:	cpi rxbyte,80	;'P'
	brne loop88		;czekaj na P
	rcall getchar
	sbrs status,t20_ms	
	rjmp loop77
	cpi rxbyte,97	;'a'
	brne loop55	
	rcall getchar
	sbrs status,t20_ms	
	rjmp loop77		
	mov nast_a,rxbyte
	rcall getchar
	sbrs status,t20_ms	
	rjmp loop77
	cpi rxbyte,98	;'b'
	brne loop77	
	rcall getchar
	sbrs status,t20_ms	
	rjmp loop77		
	mov nast_b,rxbyte
	rcall getchar
	sbrs status,t20_ms	
loop55:	rjmp loop77
	cpi rxbyte,99	;'c'
	brne loop77	
	rcall getchar
	sbrs status,t20_ms	
	rjmp loop77		
	mov nast_c,rxbyte
	rcall getchar
	sbrs status,t20_ms	
	rjmp loop77
	cpi rxbyte,100	;'d'
	brne loop77	
	rcall getchar
	sbrs status,t20_ms	
	rjmp loop77		
	mov nast_d,rxbyte
	rcall getchar
	sbrs status,t20_ms	
	rjmp loop77
	cpi rxbyte,101	;'e'
	brne loop77	
	rcall getchar
	sbrs status,t20_ms	
	rjmp loop77		
	mov nast_e,rxbyte			
	rcall getchar
	sbrs status,t20_ms	
	rjmp loop77
	cpi rxbyte,102;'f'
	brne loop77	
	rcall getchar
	sbrs status,t20_ms	
	rjmp loop77		
	mov nast_f,rxbyte
	rcall getchar
	sbrs status,t20_ms	
	rjmp loop77
	cpi rxbyte,103	;'g'
	brne loop77	
	rcall getchar
	sbrs status,t20_ms	
	rjmp loop77		
	mov nast_g,rxbyte
	rcall getchar
	sbrs status,t20_ms	
	rjmp loop77
	cpi rxbyte,104	;'h'
	brne loop77	
	rcall getchar
	sbrs status,t20_ms	
	rjmp loop77		
	mov nast_h,rxbyte
loop77:
	
		
	sbrc status,t20_ms	
	rjmp loop77	;czekaj 20 ms
	ldi txbyte,xoff
	rcall putchar
loop79:
	sbrc status,rs_sleep
	rjmp loop79		;czekaj 20 ms
	
				;tu koniec 17 ms
				;sekwencyjnie
	mov serwo_a,nast_a
	nop
	nop
	
	sbi portb,0
	mov serwo_b,nast_b
	nop
	nop
	
	sbi portb,1
	mov serwo_c,nast_c
	nop
	nop
	
	sbi portb,2
	mov serwo_d,nast_d
	nop
	nop
	
	sbi portb,3
	mov serwo_e,nast_e
	nop
	nop
	
	sbi portb,4
	mov serwo_f,nast_f
	nop
	nop
	
	sbi portb,5
	mov serwo_g,nast_g
	nop
	nop
	
	sbi portb,6
	mov serwo_h,nast_h
	nop
	nop
	
	sbi portb,7
	clr debug

loop1:	sbrc status,t1_ms
	rjmp loop1		;czekaj 1 ms
	;tu ptla odmierzania 9 us
loop99:;	rcall delay
	inc debug
	tst serwo_a
	breq stop_a
	dec serwo_a
	rjmp loop2
stop_a:
	cbi portb,0
loop2:
	tst serwo_b
	breq stop_b
	dec serwo_b
	rjmp loop3
stop_b:
	cbi portb,1
		
loop3:
	tst serwo_c
	breq stop_c
	dec serwo_c
	rjmp loop4
stop_c:
	cbi portb,2

loop4:
	tst serwo_d
	breq stop_d
	dec serwo_d
	rjmp loop5
stop_d:
	cbi portb,3

loop5:
	tst serwo_e
	breq stop_e
	dec serwo_e
	rjmp loop6
stop_e:
	cbi portb,4

loop6:
	tst serwo_f
	breq stop_f
	dec serwo_f
	rjmp loop7
stop_f:
	cbi portb,5
loop7:
	tst serwo_g
	breq stop_g
	dec serwo_g
	rjmp loop8
stop_g:
	cbi portb,6
loop8:
	tst serwo_h
	breq stop_h
	dec serwo_h
	rjmp loop9
stop_h:
	cbi portb,7
loop9: sbrs status,t20_ms	;wypad z ptli 
	rjmp loop99
	
	rjmp loop
